Index: /palm/trunk/SOURCE/Makefile
===================================================================
--- /palm/trunk/SOURCE/Makefile	(revision 1360)
+++ /palm/trunk/SOURCE/Makefile	(revision 1361)
@@ -20,5 +20,5 @@
 # Current revisions:
 # ------------------
-# 
+# cpulog added to microphysics
 # 
 # Former revisions:
@@ -341,5 +341,5 @@
 ls_forcing.o: modules.o cpulog.o mod_kinds.o
 message.o: modules.o mod_kinds.o
-microphysics.o: modules.o mod_kinds.o
+microphysics.o: modules.o cpulog.o mod_kinds.o
 modules.o: modules.f90 mod_kinds.o
 mod_kinds.o: mod_kinds.f90
Index: /palm/trunk/SOURCE/advec_s_bc.f90
===================================================================
--- /palm/trunk/SOURCE/advec_s_bc.f90	(revision 1360)
+++ /palm/trunk/SOURCE/advec_s_bc.f90	(revision 1361)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! nr and qr added
 ! 
 ! Former revisions:
@@ -926,4 +926,48 @@
        ENDIF
 
+    ELSEIF ( sk_char == 'qr' )  THEN
+
+!
+!--    Rain water content boundary condition at the bottom boundary:
+!--    Dirichlet (fixed surface rain water content).
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             sk_p(nzb,j,i)   = sk_p(nzb+1,j,i)
+             sk_p(nzb-1,j,i) = sk_p(nzb,j,i)
+             sk_p(nzb-2,j,i) = sk_p(nzb,j,i)
+          ENDDO
+       ENDDO
+
+!
+!--    Rain water content boundary condition at the top boundary: Dirichlet
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             sk_p(nzt+2,j,i)   = sk_p(nzt+1,j,i)
+             sk_p(nzt+3,j,i)   = sk_p(nzt+1,j,i)
+          ENDDO
+       ENDDO
+
+    ELSEIF ( sk_char == 'nr' )  THEN
+
+!
+!--    Rain drop concentration boundary condition at the bottom boundary:
+!--    Dirichlet (fixed surface rain drop concentration).
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             sk_p(nzb,j,i)   = sk_p(nzb+1,j,i)
+             sk_p(nzb-1,j,i) = sk_p(nzb,j,i)
+             sk_p(nzb-2,j,i) = sk_p(nzb,j,i)
+          ENDDO
+       ENDDO
+
+!
+!--    Rain drop concentration boundary condition at the top boundary: Dirichlet
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             sk_p(nzt+2,j,i)   = sk_p(nzt+1,j,i)
+             sk_p(nzt+3,j,i)   = sk_p(nzt+1,j,i)
+          ENDDO
+       ENDDO
+
     ELSEIF ( sk_char == 'e' )  THEN
 
Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 1360)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 1361)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! accelerator and vector version for qr and nr added
 ! 
 ! Former revisions:
@@ -2233,5 +2233,5 @@
        USE statistics,                                                        &
            ONLY:  sums_wspts_ws_l, sums_wsqs_ws_l, sums_wssas_ws_l,           &
-                  weight_substep
+                  sums_wsqrs_ws_l, sums_wsnrs_ws_l, weight_substep
 
        IMPLICIT NONE
@@ -2656,4 +2656,16 @@
                         *   weight_substep(intermediate_timestep_count)
                     ENDDO
+                 CASE ( 'qr' )
+                    DO  k = nzb, nzt
+                       sums_wsqrs_ws_l(k,tn) = sums_wsqrs_ws_l(k,tn)         &
+                        + ( flux_t(k) + diss_t(k) )                          &
+                        *   weight_substep(intermediate_timestep_count)
+                    ENDDO
+                 CASE ( 'nr' )
+                    DO  k = nzb, nzt
+                       sums_wsnrs_ws_l(k,tn) = sums_wsnrs_ws_l(k,tn)         &
+                        + ( flux_t(k) + diss_t(k) )                          &
+                        *   weight_substep(intermediate_timestep_count)
+                    ENDDO
 
               END SELECT
@@ -2690,5 +2702,5 @@
 !        USE statistics,                                                       &
 !            ONLY:  sums_wspts_ws_l, sums_wsqs_ws_l, sums_wssas_ws_l,          &
-!                   weight_substep
+!                   sums_wsqrs_ws_l, sums_wsnrs_ws_l, weight_substep
 
        IMPLICIT NONE
@@ -2975,5 +2987,13 @@
 !                   CASE ( 'q' )
 !                      sums_wsqs_ws_l(k,tn) = sums_wsqs_ws_l(k,tn)           &
-!                      + ( flux_t + diss_t )                                &
+!                      + ( flux_t + diss_t )                                 &
+!                      *   weight_substep(intermediate_timestep_count)
+!                   CASE ( 'qr' )
+!                      sums_wsqrs_ws_l(k,tn) = sums_wsqrs_ws_l(k,tn)         &
+!                      + ( flux_t + diss_t )                                 &
+!                      *   weight_substep(intermediate_timestep_count)
+!                   CASE ( 'nr' )
+!                      sums_wsnrs_ws_l(k,tn) = sums_wsnrs_ws_l(k,tn)         &
+!                      + ( flux_t + diss_t )                                 &
 !                      *   weight_substep(intermediate_timestep_count)
 !
Index: /palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- /palm/trunk/SOURCE/boundary_conds.f90	(revision 1360)
+++ /palm/trunk/SOURCE/boundary_conds.f90	(revision 1361)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Bottom and top boundary conditions of rain water content (qr) and 
+! rain drop concentration (nr) changed to Dirichlet
 ! 
 ! Former revisions:
@@ -271,18 +272,17 @@
        q_p(nzt+1,:,:) = q_p(nzt,:,:)   + bc_q_t_val * dzu(nzt+1)
 
-       IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.                    &
-            precipitation )  THEN
+       IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  precipitation )  THEN
 !             
-!--       Surface conditions rain water (Neumann)
+!--       Surface conditions rain water (Dirichlet)
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
-                qr_p(nzb_s_inner(j,i),j,i) = qr_p(nzb_s_inner(j,i)+1,j,i)
-                nr_p(nzb_s_inner(j,i),j,i) = nr_p(nzb_s_inner(j,i)+1,j,i)
-             ENDDO
-          ENDDO
-!
-!--       Top boundary condition for rain water (Neumann)
-          qr_p(nzt+1,:,:) = qr_p(nzt,:,:)
-          nr_p(nzt+1,:,:) = nr_p(nzt,:,:)
+                qr_p(nzb_s_inner(j,i),j,i) = 0.0_wp
+                nr_p(nzb_s_inner(j,i),j,i) = 0.0_wp
+             ENDDO
+          ENDDO
+!
+!--       Top boundary condition for rain water (Dirichlet)
+          qr_p(nzt+1,:,:) = 0.0_wp
+          nr_p(nzt+1,:,:) = 0.0_wp
            
        ENDIF
Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 1360)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 1361)
@@ -20,6 +20,7 @@
 ! Current revisions:
 ! -----------------
-! 
-! 
+! PA0363 removed
+! PA0362 changed 
+!
 ! Former revisions:
 ! -----------------
@@ -862,17 +863,11 @@
     ENDIF 
 
-    IF ( loop_optimization /= 'cache' .AND.  cloud_physics  .AND.            &
-         icloud_scheme == 0 ) THEN
+    IF ( .NOT. ( loop_optimization == 'cache'  .OR.                            &
+                 loop_optimization == 'vector' )                               &
+         .AND.  cloud_physics  .AND.  icloud_scheme == 0 )  THEN
        message_string = 'cloud_scheme = seifert_beheng requires ' // &
-                        'loop_optimization = cache'
+                        'loop_optimization = "cache" or "vector"'
        CALL message( 'check_parameters', 'PA0362', 1, 2, 0, 6, 0 )
     ENDIF 
-
-!    IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
-!         .NOT. precipitation  .AND.  .NOT. drizzle ) THEN
-!       message_string = 'cloud_scheme = seifert_beheng requires ' // &
-!                        'precipitation = .TRUE. or drizzle = .TRUE.'
-!       CALL message( 'check_parameters', 'PA0363', 1, 2, 0, 6, 0 )
-!    ENDIF 
 
 !
Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 1360)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 1361)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! tend_* removed
+! Bugfix: w_subs is not allocated anymore if it is already allocated
 ! 
 ! Former revisions:
@@ -366,8 +367,4 @@
                 ALLOCATE( qc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 #endif
-!
-!--             3D-tendency arrays
-                ALLOCATE( tend_pt(nzb:nzt+1,nysg:nyng,nxlg:nxrg),    &
-                          tend_q(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 
                 IF ( precipitation )  THEN
@@ -375,9 +372,5 @@
 !--                1D-arrays 
                    ALLOCATE ( nr_1d(nzb:nzt+1), qr_1d(nzb:nzt+1) ) 
-!
-!
-!--                3D-tendency arrays
-                   ALLOCATE( tend_nr(nzb:nzt+1,nysg:nyng,nxlg:nxrg),    &
-                             tend_qr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+
 !
 !--                2D-rain water content and rain drop concentration arrays
@@ -475,7 +468,8 @@
 !
 !-- 1D-array for large scale subsidence velocity
-    ALLOCATE ( w_subs(nzb:nzt+1) )
-    w_subs = 0.0_wp
-
+    IF ( .NOT. ALLOCATED( w_subs ) )  THEN
+       ALLOCATE ( w_subs(nzb:nzt+1) )
+       w_subs = 0.0_wp
+    ENDIF
 
 !
Index: /palm/trunk/SOURCE/init_cloud_physics.f90
===================================================================
--- /palm/trunk/SOURCE/init_cloud_physics.f90	(revision 1360)
+++ /palm/trunk/SOURCE/init_cloud_physics.f90	(revision 1361)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! sed_qc_const is now calculated here (2-moment microphysics)
 ! 
 ! Former revisions:
@@ -73,8 +73,8 @@
     USE cloud_parameters,                                                      &
         ONLY:  bfactor, cp, c_sedimentation, dpirho_l, dt_precipitation,       &
-               hyrho, l_d_cp, l_d_r, l_d_rv, l_v, mass_of_solute,              &
+               hyrho, k_st, l_d_cp, l_d_r, l_d_rv, l_v, mass_of_solute,  &
                molecular_weight_of_solute, molecular_weight_of_water, pirho_l, &
-               pt_d_t, rho_l, r_d, r_v, schmidt, schmidt_p_1d3, t_d_pt,        &
-               vanthoff, w_precipitation
+               pt_d_t, rho_l, r_d, r_v, sed_qc_const, schmidt, schmidt_p_1d3,  &
+               sigma_gc, t_d_pt, vanthoff, w_precipitation
         
     USE constants,                                                             &
@@ -108,5 +108,10 @@
 
     pirho_l  = pi * rho_l / 6.0_wp
-    dpirho_l = 1.0_wp / pirho_l 
+    dpirho_l = 1.0_wp / pirho_l
+!
+!-- constant fot the sedimentation of cloud water (2-moment cloud physics)
+    sed_qc_const = k_st * ( 3.0_wp / ( 4.0_wp * pi * rho_l )                   &
+                          )**( 2.0_wp / 3.0_wp ) *                             &
+                   EXP( 5.0_wp * LOG( sigma_gc )**2 )
 !
 !-- Calculate timestep according to precipitation
